---
title: Retrieve Multiple Datasources
description: Retrieve all datasources from your Storyblok space with pagination support using the Content Delivery API.
url: https://storyblok.com/docs/api/content-delivery/v2/datasources/retrieve-multiple-datasources
---

# Retrieve Multiple Datasources

Returns an array of all datasources (as [datasource objects](/docs/api/content-delivery/v2/datasources/the-datasource-object)).

GET

```html
https://api.storyblok.com/v2/cdn/datasources
```

> [!NOTE]
> This endpoint is paginated by default, including a maximum of 1000 datasource entries in the response. See [Pagination](/docs/api/content-delivery/v2/getting-started/paginatio).

## Query parameters

-   `token` (required) (string)
    
    A preview or public access token configured in a space.
    
-   `page` (number)
    
    Default: `1` (See [Pagination](/docs/api/content-delivery/v2/getting-started/pagination))
    
-   `per_page` (number)
    
    Default: `25`, Max: `1000` (See [Pagination](/docs/api/content-delivery/v2/getting-started/pagination))
    

## Response properties

-   `datasources`
    
    An array of [datasource objects](/docs/api/content-delivery/v2/datasources/the-datasource-object)
    
-   `cv` (number)
    
    Cached version Unix timestamp (see [Cache Invalidation](/docs/api/content-delivery/v2/getting-started/cache-invalidation))
    

## Examples

-   cURL
    
    ```shellscript
    curl "https://api.storyblok.com/v2/cdn/datasources\
    ?token=ask9soUkv02QqbZgmZdeDAtt"
    ```
    
-   JS
    
    ```javascript
    // storyblok-js-client@>=7, node@>=18
    import Storyblok from "storyblok-js-client";
    
    const storyblok = new Storyblok({
      accessToken: "krcV6QGxWORpYLUWt12xKQtt",
    });
    
    try {
      const response = await storyblok.get('cdn/datasources', {})
      console.log({ response })
    } catch (error) {
      console.log(error)
    }
    ```
    
-   PHP
    
    ```php
    $client = new \Storyblok\Client('YOUR_STORYBLOK_SPACE_ACCESS_TOKEN');
    
    $client->get('datasources')->getBody();
    ```
    
-   Java
    
    ```java
    HttpResponse<String> response = Unirest.get("https://api.storyblok.com/v2/cdn/datasources?token=ask9soUkv02QqbZgmZdeDAtt")
      .asString();
    ```
    
-   C#
    
    ```csharp
    var client = new RestClient("https://api.storyblok.com/v2/cdn/datasources?token=ask9soUkv02QqbZgmZdeDAtt");
    var request = new RestRequest(Method.GET);
    
    IRestResponse response = client.Execute(request);
    ```
    
-   Python
    
    ```python
    import requests
    
    url = "https://api.storyblok.com/v2/cdn/datasources"
    
    querystring = {"token":"ask9soUkv02QqbZgmZdeDAtt"}
    
    payload = ""
    headers = {}
    
    response = requests.request("GET", url, data=payload, headers=headers, params=querystring)
    
    print(response.text)
    ```
    
-   Ruby
    
    ```ruby
    require 'storyblok'
    client = Storyblok::Client.new(token: 'YOUR_TOKEN')
    
    client.get('datasources')
    ```
    
-   Swift
    
    ```swift
    let storyblok = URLSession(storyblok: .cdn(accessToken: "ask9soUkv02QqbZgmZdeDAtt"))
    let request = URLRequest(storyblok: storyblok, path: "datasources")
    let (data, _) = try await storyblok.data(for: request)
    print(try JSONSerialization.jsonObject(with: data))
    ```
    
-   Kotlin
    
    ```kotlin
    val client = HttpClient {
        install(Storyblok(CDN)) {
            accessToken = "ask9soUkv02QqbZgmZdeDAtt"
        }
    }
    
    val response = client.get("datasources")
    
    println(response.body<JsonElement>())
    ```

Response

```json
{
  "datasources": [
    {
      "id": 313699,
      "name": "Background Color Options",
      "slug": "background-color-options",
      "dimensions": []
    },
    {
      "id": 313701,
      "name": "Button Color Options",
      "slug": "button-color-options",
      "dimensions": []
    },
    {
      "id": 313702,
      "name": "Product Labels",
      "slug": "product-labels",
      "dimensions": [
        {
          "id": 68105,
          "name": "German",
          "entry_value": "de",
          "datasource_id": 313702,
          "created_at": "2024-03-15T12:17:10.279Z",
          "updated_at": "2024-03-15T12:17:10.279Z"
        }
      ]
    }
  ],
  "cv": 1710350440
}
```

## Pagination

-   [Previous: Retrieve a Single Datasource](/docs/api/content-delivery/v2/datasources/retrieve-a-single-datasource)
-   [Next: Retrieve Multiple Datasource Entries](/docs/api/content-delivery/v2/datasources/retrieve-multiple-datasource-entries)
